#ifndef FIXEDSTACK_H_
#define FIXEDSTACK_H_

template <class T>
class FixedStack
{
	int* m_memory;
	const int m_maxItems;
	int m_numItems;

public:
	FixedStack(unsigned numItems)
		: m_maxItems(numItems)
		, m_numItems(0)
	{
		m_memory = new int[((sizeof(T)+sizeof(int)-1)/sizeof(int)) * m_maxItems];
	}
	~FixedStack()
	{
		delete[] m_memory;
	}

	int MaxItems() const {return m_maxItems;}
	int NumItems() const {return m_numItems;}

	const T& operator[](int index) const {ASSERT(index >= 0); ASSERT(index < m_numItems); return reinterpret_cast<T*>(m_memory)[index];}
	T& operator[](int index) {ASSERT(index >= 0); ASSERT(index < m_numItems); return reinterpret_cast<T*>(m_memory)[index];}

	void Push(const T& item) 
	{
		ASSERT(m_numItems < m_maxItems);
		new(&reinterpret_cast<T*>(m_memory)[m_numItems]) T(item);
		++m_numItems;
	}
	void Pop()
	{
		ASSERT(m_numItems > 0);
		--m_numItems;
	}

	T& Top()
	{
		return operator[](m_numItems-1);
	}
	const T& Top() const
	{
		return operator[](m_numItems-1);
	}
};

#endif
