#ifndef GRAPHICSCONTEXT_H_
#define GRAPHICSCONTEXT_H_

#include <Algebra.h>
#include <GraphicsFrame.h>

class GraphicsContext
{
public:
	class RenderOptions
	{
		Matrix<4,4,false> m_projectionMatrix;

	public:
		RenderOptions(const Matrix<4,4>& projMat)
			: m_projectionMatrix(projMat)
		{};

		const Matrix<4,4,false> GetProjectionMatrix() const {return m_projectionMatrix;}
	};

	GraphicsContext() {};
	virtual ~GraphicsContext() {};

	virtual void RenderGraphicsFrame(GraphicsFrame& frame, const RenderOptions& options) = 0;
	virtual void FlushWait() = 0;

	virtual int GetWidth() = 0;
	virtual int GetHeight() = 0;

	virtual void ResizeScreen(int width, int height) = 0;
};

#endif
