#ifndef OSWINDOW_H_
#define OSWINDOW_H_

#include <GenericWindow.h>
#include <string>

#include <Utils.h>

#include <iostream>

#include <string>

class OSWindow : public GenericWindow
{
	public:
	enum Mode
	{
		M_WINDOWED,
		M_FULLSCREEN,
	};

	class Pimpl
	{
		public:
		virtual ~Pimpl() {};

		virtual GraphicsContext& GetGraphicsContext() = 0;
		virtual KeyboardInput& GetKeyboardInput() = 0;
		virtual MouseInput& GetMouseInput() = 0;
		virtual GenericWindow::MousePosition GetLastMousePosition() = 0;

		virtual float GetWidth() = 0;
		virtual float GetHeight() = 0;

		virtual void SetWindowMode(Mode mode) = 0;
		virtual Mode GetWindowMode() = 0;
	};

	private:
	Pimpl* m_pimpl;

	public:

	OSWindow(const std::string& winTitle, int width, int height);
	virtual ~OSWindow();

	virtual GraphicsContext& GetGraphicsContext() {return m_pimpl->GetGraphicsContext();}
	virtual KeyboardInput& GetKeyboardInput() {return m_pimpl->GetKeyboardInput();}
	virtual MouseInput& GetMouseInput() {return m_pimpl->GetMouseInput();}
	virtual GenericWindow::MousePosition GetLastMousePosition() {return m_pimpl->GetLastMousePosition();}

	virtual float GetWidth() {return m_pimpl->GetWidth();}
	virtual float GetHeight() {return m_pimpl->GetHeight();}

	void SetWindowMode(Mode mode) {m_pimpl->SetWindowMode(mode);} // Sets the current window mode
	Mode GetWindowMode() {return m_pimpl->GetWindowMode();} // Returns the current mode of the window
};

#endif
