#ifndef _TOP_UTILS_H_
#define _TOP_UTILS_H_

#include <string>

#ifdef COMPILER_MSVC

	#define ALIGNED(x) __declspec(align(x))

#elif COMPILER_GCC

	#define ALIGNED(x) __attribute__ ((aligned (x)))

#endif



#ifdef DEBUG

#define ASSERT(cond) top_assert(cond, #cond, __FILE__, __LINE__)
#define ASSERTMSG(cond, msg) top_assert(cond, #cond, __FILE__, __LINE__, msg);

#else

#define ASSERT(cond)
#define ASSERTMSG(cond, msg)

#endif

void top_assert(bool cond, const char* condStr, const char* file, int line, const char* msg="");

#endif
