#include "MouseInput.h"

void MouseInput::RegisterMoveHandler(const MoveEventHandler& handler)
{
	Mutex::ScopedLock lock(m_handlerLock);

	ASSERT(m_velHandler == 0);
	m_velHandler = handler;
}

void MouseInput::DeRegisterMoveHandler()
{
	Mutex::ScopedLock lock(m_handlerLock);

	ASSERT(m_velHandler != 0);
	m_velHandler = 0;
}

void MouseInput::RegisterButtonHandler(const ButtonEventHandler& handler)
{
	Mutex::ScopedLock lock(m_handlerLock);

	ASSERT(m_buttonHandler == 0);
	m_buttonHandler = handler;
}

void MouseInput::DeRegisterButtonHandler()
{
	Mutex::ScopedLock lock(m_handlerLock);

	ASSERT(m_buttonHandler != 0);
	m_buttonHandler = 0;
}

void MouseInput::PostMoveEvent(const MoveEvent& velChange)
{
	Mutex::ScopedLock lock(m_handlerLock);

	if(!m_velHandler.empty()) m_velHandler(velChange);
}

void MouseInput::PostButtonEvent(const ButtonEvent& button)
{
	Mutex::ScopedLock lock(m_handlerLock);

	if(!m_buttonHandler.empty()) m_buttonHandler(button);
}

