#ifndef PATHRELATIVETO_H_
#define PATHRELATIVETO_H_

#include <boost/filesystem.hpp>

/** Returns a path representing one path relative to another.
 * @param relativeTo The returned path will be relative to this path.
 * @param targetPath The returned path will be this path, except relative to relativeTo.
 * @return A path equivalent to targetPath, except relative to relativeTo.
 */
boost::filesystem::path PathRelativeTo(const boost::filesystem::path& relativeTo, const boost::filesystem::path& targetPath);

#endif
