#include "EditCamera.h"

#include <R3Utils.h>

EditCamera::EditCamera()
: m_focusPoint(0,0,0,1)
, m_distance(2.0f)
{
}

Matrix<4,4> EditCamera::GetModelView() const
{
	Matrix<4,4> modelView(Matrix<4,4>::Identity);

	// Apply the translation, then the rotation, then apply the distance translation

	modelView
		= MakeTranslationMatrix(Vector<3>(0,0,-m_distance))
		* m_rotation.Conjugate().ToMatrix()
		* MakeTranslationMatrix(-m_focusPoint.Trim());

	return modelView;
}
