
#include "MainSystemFrame.h"

#include <SceneExplorer.h>
#include <WorldDefinition.h>

#include <Model.h>
#include <ScopedFStream.h>
#include <ThreadPrimitives.h>
#include <PotentialObject.h>

#include <wx/wx.h>

#include <iostream>



class MyApp : public wxApp
{
	PotentialObject<FileFetcher> m_fetcher;
	PotentialObject<ResourceManager> m_resMan;
	MainSystemFrame* m_mainFrame;

	virtual ~MyApp()
	{
	}

	virtual bool OnInit();
	virtual int OnExit();

public:
	MyApp()
	{};
};

enum
{
	ID_Quit = 1,
	ID_About,
};


IMPLEMENT_APP(MyApp)

bool MyApp::OnInit()
{
	if(!wxApp::OnInit()) return false;

	new(m_fetcher) FileFetcher(20000000);
	new(m_resMan) ResourceManager(g_standardAllocator, 100000000, *m_fetcher);
	m_mainFrame = new MainSystemFrame(wxString("Scene Composer"), wxDefaultPosition, wxSize(800,600), *m_resMan);
 
	m_mainFrame->Show(TRUE);
	SetTopWindow(m_mainFrame);

	return TRUE;
}

int MyApp::OnExit()
{
	int ret = wxApp::OnExit();

	m_resMan.Clear();
	m_fetcher.Clear();

	return ret;
}


#ifdef PLAT_WIN32

int main(int argc, char* argv[])
{
	return WinMain(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), SW_SHOWNORMAL);
}

#endif
